///////////////////////////////////////////////////////
// reorder arguments and return number of switches

#include <malloc.h> // malloc()
#include <string.h> // memcpy()

#include "cdecls.h"
LQ_BEGIN_CDECLS;

int reorder_args(int argc, char** argv)
{
  // make literal copy of argv in temporary list
  char** tmp_args = (char**)malloc(argc * sizeof(char**));
  memcpy(tmp_args, argv, argc * sizeof(char**));
  
  int cnt = 1;        // current copy back number, app path is at [0] still
  int nswitches = 0;  // the value to return
  int is_assign = 0;  // enable --switch '=' value switch syntax
  // copy switches back first
  for(int i = 1; i < argc; i++)
  {
    if(is_assign)
      argv[cnt++] = tmp_args[i];
    else if(tmp_args[i][0] == '-')
      argv[cnt++] = tmp_args[i];
    else if(tmp_args[i][0] == '=')
    {
      argv[cnt++] = tmp_args[i];
      if(strlen(tmp_args[i]) == 1)
        is_assign++;
      continue;
    }
    is_assign = 0;
  }
  nswitches = cnt - 1; // number of actual switches
  
  // copy non-switches back next
  for(int i = 1; i < argc; i++)
    if(tmp_args[i][0] != '-')
      argv[cnt++] = tmp_args[i];
  
  free(tmp_args);
  return nswitches;
}

LQ_END_CDECLS;

