#include <string.h>
#include <stdio.h>
#include <stdlib.h> // setenv()
#include <unistd.h> // chdir()

#include "utils.h"

// returns 0 if ok
int make_check(int argc, char** argv)
{
  if(argc == 1 || strcmp(argv[1], "working"))
  {
    printf(
        "Only run this from the makefile as 'make <app>' where <app>\n"
        "is the name of the function minus the 'mktools' prefix.\n"
        "\n"
        "Press ENTER to abort now.\n"
        "\n");
        getchar();
        return 1;
  }
  else
    return 0;
}

// change dir and set PWD env var
void cd(const char* dir)
{
  chdir(dir);
  // resolves path and sets PWD if path is a symbolic link.
  // docs are unclear.  the call itself may set PWD.
  // doc: libc_14.html#IDX1416
  setenv("PWD", (char*)get_current_dir_name(), 1);
}

// change dir to `dirname arg`. basically changes directory to
// path up to the last '/'
void cd_dirname(const char* execpath)
{
  char pad[256];
  char* p;
  sprintf(pad, execpath);
  p = strrchr(pad, '/');
  if(p)
  {
    *p = 0; // needs some more checks.
    cd(pad);
  }
}


