#include <stdlib.h> // getenv()
#include <stdio.h>  // sprintf()
#include <string.h> // strcmp()

#include "utils.h"
#include "slist.h"
#include "filename.h"

void dbg(){}

static void find_diff(char*** pdiffer);
static void slist_print(char*** plist);
static void chk_diff(char*** pdiff);

char HERE[245];
#define PREFIX getenv("PREFIX")

int main(int argc, char** argv)
{
  dbg();
  // cd `dirname "$0"`
  // cd ..
  
  cd_dirname(argv[0]);
  cd("..");
  
  if(make_check(argc, argv))
    return 1;
  
  // HERE="$PWD"
  sprintf(HERE, getenv("PWD"));
  
  char** filelist = slist_new();
  slist_fileRead(&filelist, "files.dat");
  slist_fileRead(&filelist, "links.dat");
  if(slist_count(filelist) == 0)
  {
    printf("No data in dat files\n");
    return 1;
  }
  
  cd("TREE");
  
  int nfiles = slist_count(filelist);
  int nmissing = 0;
  size_t sz1, sz2;
  char prefix_path[256];
  int prefix_len = sprintf(prefix_path, "%s", PREFIX);
  if(prefix_path[strlen(prefix_path) - 1] != '/')
  {
    strcat(prefix_path, "/");
    prefix_len++;
  }
  
  for(int i = 0; i < nfiles; i++)
  {
    sz1 = filename_size(filelist[i]);
    strcpy(prefix_path+prefix_len, filelist[i]);
    sz2 = filename_size(prefix_path);
    if(sz1 != sz2)
    {
      printf("%s NOT installed\n", filelist[i]);
      nmissing++;
    }
  }
  if(nfiles)
  {
    if(nmissing == nfiles)
      printf("No files are installed.\n");
    else if(nmissing != 0)
      printf("Only some files are installed (\?\?\?).\n");
    else
      printf("All files are installed\n");
  }
  
  cd(HERE);
  return 0;
} // main
  

static void find_diff(char*** pdiffer)
{
  char cmd[256];
  
  // local list=`find * -type f`
  char** list = slist_new();
  slist_pipeRead(&list, "find * -type f");  
  //for i in $list; do diff -q $i $PREFIX/$i; done
  int nlist = slist_count(list);
  for(int i = 0; i < nlist; i++)
  {
    sprintf(cmd, "diff -q %s %s/%s 2>/dev/null", list[i], PREFIX, list[i]);
    slist_pipeRead(pdiffer, cmd);
  }
}
  

static void chk_diff(char*** pdiff)
{
  //  if [ "$1" != "" ]; then
  if(slist_getCount(pdiff) == 0)
    printf("NOT ");
  else
    printf("IS ");
  printf("installed\n");
}

static void slist_print(char*** plist)
{
  int n = slist_getCount(plist);
  for(int i = 0; i < n; i++)
    printf("%s\n", slist_get(plist, i));
}
