#!/bin/sh

#####################################################
# the destination for copying files
#####################################################

HERE=$PWD


#####################################################
# the source for copying files
#####################################################

APPPATH=`readlink "$0"`
if [ "$APPPATH" == "" ]; then
  APPPATH="$0"
fi

THERE=`dirname "$APPPATH"`

#####################################################
# load the current directory with the files 
#####################################################

cp -rf $THERE/files/* $HERE
chown $USER:users -R * 2>/dev/null

#####################################################
# try to rename the new files to their eventual
# real names but don't overwrite any preexisting ones.
#####################################################

if [ ! -e Makefile ]; then
    cp Makefile-new Makefile
fi

rm Makefile-new

if [ ! -e mk_postinstall ]; then
    cp mk_postinstall-new mk_postinstall
fi

rm mk_postinstall-new

if [ ! -e mk_postremove ]; then
    cp mk_postremove-new mk_postremove
fi

rm mk_postremove-new

if [ ! -e deps.dat ]; then
    cp deps.dat-new deps.dat
fi

rm deps.dat-new

# init an empty directory tree if it doesn't exist
mkdir -p TREE

